//
//  Example
//  man
//
//  Created by man on 11/11/2018.
//  Copyright © 2018 man. All rights reserved.
//

import Foundation

@objc public class CocoaDebugSettings: NSObject {

    @objc public static let shared = CocoaDebugSettings()

    @objc public var responseShake: Bool = false {
        didSet {
            UserDefaults.standard.set(responseShake, forKey: "responseShake_CocoaDebug")
            UserDefaults.standard.synchronize()
        }
    }
//    @objc public var responseShakeNetworkDetail: Bool = false {
//        didSet {
//            UserDefaults.standard.set(responseShakeNetworkDetail, forKey: "responseShakeNetworkDetail_CocoaDebug")
//            UserDefaults.standard.synchronize()
//        }
//    }
    @objc public var firstIn: String? = nil {
        didSet {
            UserDefaults.standard.set(firstIn, forKey: "firstIn_CocoaDebug")
            UserDefaults.standard.synchronize()
        }
    }
    @objc public var disableCrashRecording: Bool = false {
        didSet {
            UserDefaults.standard.set(disableCrashRecording, forKey: "disableCrashRecording_CocoaDebug")
            UserDefaults.standard.synchronize()
            
            if disableCrashRecording == false {
                CrashLogger.shared.enable = true
            }else{
                CrashStoreManager.shared.resetCrashs()
            }
        }
    }
    @objc public var disableHTMLConsoleMonitoring: Bool = false {
        didSet {
            UserDefaults.standard.set(disableHTMLConsoleMonitoring, forKey: "disableHTMLConsoleMonitoring_CocoaDebug")
            UserDefaults.standard.synchronize()
        }
    }
    @objc public var disableLogMonitoring: Bool = false {
        didSet {
            UserDefaults.standard.set(disableLogMonitoring, forKey: "disableLogMonitoring_CocoaDebug")
            UserDefaults.standard.synchronize()
        }
    }
    @objc public var disableNetworkMonitoring: Bool = false {
        didSet {
            UserDefaults.standard.set(disableNetworkMonitoring, forKey: "disableNetworkMonitoring_CocoaDebug")
            UserDefaults.standard.synchronize()
        }
    }
    @objc public var visible: Bool = false {
        didSet {
            UserDefaults.standard.set(visible, forKey: "visible_CocoaDebug")
            UserDefaults.standard.synchronize()
        }
    }
    @objc public var showBubbleAndWindow: Bool = false {
        didSet {
            UserDefaults.standard.set(showBubbleAndWindow, forKey: "showBubbleAndWindow_CocoaDebug")
            UserDefaults.standard.synchronize()
            
            let x = WindowHelper.shared.vc.bubble.frame.origin.x
            let width = WindowHelper.shared.vc.bubble.frame.size.width
            
            if showBubbleAndWindow == true
            {
                if x > 0 {
                    WindowHelper.shared.vc.bubble.frame.origin.x = UIScreen.main.bounds.size.width - width/8*7
                }else{
                    WindowHelper.shared.vc.bubble.frame.origin.x = -width + width/8*7
                }
                WindowHelper.shared.enable()
            }
            else
            {
                if x > 0 {
                    WindowHelper.shared.vc.bubble.frame.origin.x = UIScreen.main.bounds.size.width
                }else{
                    WindowHelper.shared.vc.bubble.frame.origin.x = -width
                }
                WindowHelper.shared.disable()
            }
        }
    }
    @objc public var serverURL: String? = nil {
        didSet {
            UserDefaults.standard.set(serverURL, forKey: "serverURL_CocoaDebug")
            UserDefaults.standard.synchronize()
        }
    }
    @objc public var tabBarSelectItem: Int {
        didSet {
            UserDefaults.standard.set(tabBarSelectItem, forKey: "tabBarSelectItem_CocoaDebug")
            UserDefaults.standard.synchronize()
        }
    }
    @objc public var logSelectIndex: Int {
        didSet {
            UserDefaults.standard.set(logSelectIndex, forKey: "logSelectIndex_CocoaDebug")
            UserDefaults.standard.synchronize()
        }
    }
    @objc public var networkLastIndex: Int {
        didSet {
            UserDefaults.standard.set(networkLastIndex, forKey: "networkLastIndex_CocoaDebug")
            UserDefaults.standard.synchronize()
        }
    }
    @objc public var bubbleFrameX: Float {
        didSet {
            UserDefaults.standard.set(bubbleFrameX, forKey: "bubbleFrameX_CocoaDebug")
            UserDefaults.standard.synchronize()
        }
    }
    @objc public var bubbleFrameY: Float {
        didSet {
            UserDefaults.standard.set(bubbleFrameY, forKey: "bubbleFrameY_CocoaDebug")
            UserDefaults.standard.synchronize()
        }
    }
    @objc public var logSearchWordDefault: String? = nil {
        didSet {
            UserDefaults.standard.set(logSearchWordDefault, forKey: "logSearchWordDefault_CocoaDebug")
            UserDefaults.standard.synchronize()
        }
    }
    @objc public var logSearchWordColor: String? = nil {
        didSet {
            UserDefaults.standard.set(logSearchWordColor, forKey: "logSearchWordColor_CocoaDebug")
            UserDefaults.standard.synchronize()
        }
    }
    @objc public var logSearchWordH5: String? = nil {
        didSet {
            UserDefaults.standard.set(logSearchWordH5, forKey: "logSearchWordH5_CocoaDebug")
            UserDefaults.standard.synchronize()
        }
    }
    @objc public var networkSearchWord: String? = nil {
        didSet {
            UserDefaults.standard.set(networkSearchWord, forKey: "networkSearchWord_CocoaDebug")
            UserDefaults.standard.synchronize()
        }
    }
    @objc public var mainColor: String {
        didSet {
            UserDefaults.standard.set(mainColor, forKey: "mainColor_CocoaDebug")
            UserDefaults.standard.synchronize()
            _NetworkHelper.shared().mainColor = mainColor.hexColor
        }
    }
    @objc public var tabBarControllers: [UIViewController]? = nil
    
    //share via email
    @objc public var emailToRecipients: [String]? = nil
    @objc public var emailCcRecipients: [String]? = nil
    
    //objc
    @objc public var logMaxCount: Int {
        didSet {
            _NetworkHelper.shared().logMaxCount = logMaxCount
        }
    }
    @objc public var onlyURLs: [String]? = nil {
        didSet {
            _NetworkHelper.shared().onlyURLs = onlyURLs
        }
    }
    @objc public var ignoredURLs: [String]? = nil {
        didSet {
            _NetworkHelper.shared().ignoredURLs = ignoredURLs
        }
    }
    
    
    private override init() {
        responseShake = UserDefaults.standard.bool(forKey: "responseShake_CocoaDebug")
//        responseShakeNetworkDetail = UserDefaults.standard.bool(forKey: "responseShakeNetworkDetail_CocoaDebug")
        firstIn = UserDefaults.standard.string(forKey: "firstIn_CocoaDebug")
        serverURL = UserDefaults.standard.string(forKey: "serverURL_CocoaDebug")
        visible = UserDefaults.standard.bool(forKey: "visible_CocoaDebug")
        showBubbleAndWindow = UserDefaults.standard.bool(forKey: "showBubbleAndWindow_CocoaDebug")
        disableCrashRecording = UserDefaults.standard.bool(forKey: "disableCrashRecording_CocoaDebug")
        disableHTMLConsoleMonitoring = UserDefaults.standard.bool(forKey: "disableHTMLConsoleMonitoring_CocoaDebug")
        disableLogMonitoring = UserDefaults.standard.bool(forKey: "disableLogMonitoring_CocoaDebug")
        disableNetworkMonitoring = UserDefaults.standard.bool(forKey: "disableNetworkMonitoring_CocoaDebug")
        tabBarSelectItem = UserDefaults.standard.integer(forKey: "tabBarSelectItem_CocoaDebug")
        logSelectIndex = UserDefaults.standard.integer(forKey: "logSelectIndex_CocoaDebug")
        networkLastIndex = UserDefaults.standard.integer(forKey: "networkLastIndex_CocoaDebug")
        bubbleFrameX = UserDefaults.standard.float(forKey: "bubbleFrameX_CocoaDebug")
        bubbleFrameY = UserDefaults.standard.float(forKey: "bubbleFrameY_CocoaDebug")
        logSearchWordDefault = UserDefaults.standard.string(forKey: "logSearchWordDefault_CocoaDebug")
        logSearchWordColor = UserDefaults.standard.string(forKey: "logSearchWordColor_CocoaDebug")
        logSearchWordH5 = UserDefaults.standard.string(forKey: "logSearchWordH5_CocoaDebug")
        networkSearchWord = UserDefaults.standard.string(forKey: "networkSearchWord_CocoaDebug")
        mainColor = UserDefaults.standard.string(forKey: "mainColor_CocoaDebug") ?? "#42d459"

        //objc
        logMaxCount = _NetworkHelper.shared().logMaxCount
        onlyURLs = _NetworkHelper.shared().onlyURLs
        ignoredURLs = _NetworkHelper.shared().ignoredURLs
    }
}
